import { Component, OnInit, ViewChild } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { STColumn, STComponent, STData } from '@delon/abc/st';
import { SFComponent, SFDateWidgetSchema, SFSchema, SFSelectWidgetSchema, SFUISchema } from '@delon/form';
import { ShipperBaseService } from '@shared';
import { NzModalService } from 'ng-zorro-antd/modal';
import { TaxManagementService } from '../../services/tax-management.service';

@Component({
  selector: 'app-tax-management-invoice-reporting',
  templateUrl: './invoice-reporting.component.html',
  styleUrls: ['./invoice-reporting.component.less']
})
export class TaxManagementInvoiceReportingComponent implements OnInit {
  _$expand = false;
  ui!: SFUISchema;
  schema!: SFSchema;
  columns!: STColumn[];
  @ViewChild('st', { static: false }) st!: STComponent;
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  tabType!: string;
  isLoading: boolean = false;
  tabs: any[] = [
    { name: '待上传', value: '1' },
    { name: '上传中', value: '2' },
    { name: '已上传', value: '3' },
    { name: '异常', value: '4' },
    { name: '全部', value: '' }
  ];
  selectedIndex = ''; //选择的项目
  serviceTel = '';
  constructor(
    public service: TaxManagementService,
    private router: Router,
    private ar: ActivatedRoute,
    public shipperservice: ShipperBaseService,
    private modal: NzModalService,
    public shipperSrv: ShipperBaseService
  ) {
  }

  /**
   * 查询字段个数
   */
  get queryFieldCount(): number {
    return Object.keys(this.schema?.properties || {}).length;
  }

  /**
   * 查询参数
   */
  get reqParams() {
    const params = Object.assign({}, this.sf?.value || {});
    delete params._$expand;
    return { ...params };
  }

  /**
   * 选中行
   */
  get selectedRows() {
    return this.st?.list.filter((item: any) => item.checked) || [];
  }

  /**
   * 伸缩查询条件
   */
  expandToggle() {
    this._$expand = !this._$expand;
    this.sf?.setValue('/_$expand', this._$expand);
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
    this._$expand = false;
    this.isLoading = true
  }
  /**
   * 程序初始化入口
   */
  ngOnInit() {
    this.initSF();
    this.initST();
  }

  /**
   * 初始化查询表单
   */
  initSF() {
    this.schema = {
      properties: {
        _$expand: { type: 'boolean', ui: { hidden: true } },
        // uploadSts: {
        //   title: '上传状态',
        //   type: 'string',
        //   default: '1',
        //   enum: [
        //     { label: '全部', value: '' },
        //     { label: '待上传', value: '1'},
        //     { label: '上传中', value: '2' },
        //     { label: '已上传', value: '3' },
        //     { label: '异常', value: '4' }
        //   ],

        //   ui: {
        //     placeholder: '请选择',
        //     widget: 'select',
        //     allowClear: true
        //   }
        // },
        ltdId: {
          type: 'string',
          title: '网络货运人',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            allowClear: true,
            asyncData: () => this.shipperservice.getNetworkFreightForwarder()
          }
        },
        arto: {
          type: 'string',
          title: '购买方',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            allowClear: true,
            asyncData: () => this.service.getCRMCustomerId()
          }
        },
        billHCode: {
          title: '订单号', type: 'string',
          ui: {
            placeholder: '请输入'
          }
        },
        invoicedate: {
          title: '开票日期',
          type: 'string',
          ui: {
            widget: 'sl-from-to',
            type: 'date',
            format: 'yyyy-MM-dd',
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFDateWidgetSchema,
        },
        uoloadDate: {
          title: '上传日期',
          type: 'string',
          ui: {
            widget: 'sl-from-to',
            type: 'date',
            format: 'yyyy-MM-dd',
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFDateWidgetSchema,
        },
        invoiceno: {
          type: 'string',
          title: '发票号码',
          ui: {
            placeholder: '请输入',
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          },
        },
        invoiceno2: {
          type: 'string',
          title: '发票代码',
          ui: {
            placeholder: '请输入',
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          },
        },
        sts: {
          title: '发票状态',
          type: 'string',
          ui: {
            widget: 'dict-select',
            containsAllLabel: true,
            params: { dictKey: 'vatinv:status' },
            containAllLable: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFSelectWidgetSchema
        },
      },
    };
    this.ui = {
      '*': { spanLabelFixed: 120, grid: { span: 8, gutter: 4 }, enter: () => this.search() },
      $time: { grid: { span: 24 } },
    };
  }

  /**
   * 初始化数据列表
   */
  initST() {
    this.columns = [
      { title: '', type: 'checkbox', className: 'text-center', width: '60px', },
      { title: '上传状态', render: 'uploadSts', className: 'text-center', width: '120px', },
      { title: '发票类型', render: 'invoiceType', className: 'text-center', width: '120px', },
      {
        title: '发票号码',
        index: 'invoiceno',
        render: 'invoiceNO',
        className: 'text-center',
        width: '150px',
      },
      { title: '发票代码', index: 'invoiceno2', className: 'text-center', width: '150px', },
      {
        title: '网络货运人',
        index: 'ltdName',
        className: 'text-center',
        width: '180px',
      },
      { title: '购买方企业名称', index: 'artoname', render: 'artoname', className: 'text-center', width: '200px' },
      { title: '购买方统一社会信用代码', index: 'artotaxno', className: 'text-center', width: '200px' },
      { title: '订单号', index: 'billHCode', render: 'billHCode', className: 'text-center', width: '120px' },
      { title: '货物名称', index: 'goodsinfo', className: 'text-center', width: '180px' },
      { title: '价税合计', index: 'vatmoney', className: 'text-center', width: '180px' },
      { title: '开票日期', index: 'invoicedate', className: 'text-center', width: '180px' },
      { title: '发票所属月份', index: 'invoicemonth', className: 'text-center', width: '250px' },
      { title: '发票状态', index: 'sts', className: 'text-center', width: '200px' },
      { title: '上传日期', index: 'uoloadDate', className: 'text-center', width: '200px' },
    ];
  }



  /**
   *撤回
   * @param record 记录实例
   */
  recall() {
    if (this.selectedRows.length === 0) {
      this.openWainingModal('请选择需要撤回的数据');
      return;
    }
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.id);
    });
    this.modal.confirm({
      nzTitle: '撤回提示',
      nzContent: ' 撤回后可以重新上传，重新上传会覆盖已上传数据，确定要撤回？',
      nzOkText: '确定',
      nzCancelText: '取消',
      nzOnOk: () => {
        this.service.request(this.service.$api_get_recessionTaxOrder, params).subscribe((res: any) => {
          if (res) {
            this.service.msgSrv.success('撤销成功');
            this.search();
          }
        })
      }
    });

  }
  /**
   *撤销
   * @param record 记录实例
   */
  resetData() {
    if (this.selectedRows.length === 0) {
      this.openWainingModal('请选择需要更新的数据！');
      return;
    }
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.billId);
    });
    this.service.request(this.service.$api_get_renewalOrderById, params).subscribe((res: any) => {
      if (res) {
        this.service.msgSrv.success('更新成功');
        this.st.load(1);
      }
    })
  }
  /**
   *撤销
   * @param record 记录实例
   */
  unnormal(value: any) {
    // if (this.selectedRows.length === 0) {
    //   this.openWainingModal('请选择需要更新的数据！');
    //   return;
    // }
    console.log(this.selectedRows);
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.id);
    });
    this.modal.confirm({
      nzTitle: '税务审核结果',
      nzContent: '订单结算时间所在月份与申报月份不一致',
      nzOkText: '确定',
      nzCancelText: '',
      nzOnOk: () => {
        this.service.request(this.service.$api_get_recessionTaxOrder, params).subscribe((res: any) => {
          if (res) {
            this.service.msgSrv.success('撤销成功');
            this.search();
          }
        })
      }
    });

  }

  selectChange(item: any) {
    console.log(item);

    this.selectedIndex = item?.value || '';
    setTimeout(() => {
      this.st.load();
    })
  }

  /**
   * 查看当行数据
   */
  view(record: STData) {
    // this.router.navigate(['../view', record.uuid], { relativeTo: this.ar });
    this.router.navigate(['../detail'], {
      queryParams: {
        id: record.id,
      },
      relativeTo: this.ar
    });
  }

  /**
   * 上传
   */
  upload() {
    if (this.selectedRows.length === 0) {
      this.openWainingModal('请选择需要上传的数据');
      return;
    }
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.id);
    });
    this.service.request(this.service.$api_get_uploadingTaxOrder, params).subscribe((res: any) => {
      if (res) {
        this.service.msgSrv.success('上传成功');
        this.st.load();
      }
    })
  }


  /**
   * 查看监管审核结果
   */
  viewAuditResult(record: any) {
    if (record?.billStatus !== '2') {
      return;
    }
    this.openWainingModal('监管审核结果', record?.result)
  }


  search() {
    this.st.load(1);
  }

  /**
  * 异步导出
  */
  export() {
    this.service.exportStart(this.sf?.value, this.service.$api_async_export_order_reporting_list);
  }

  openWainingModal(content: string, title = '提示') {
    this.modal.warning({
      nzMask: false,
      nzTitle: title,
      nzContent: content,
    })
  }

}
